<%@ page import="org.apache.log4j.Logger" %>
<%@ page import="sun.misc.BASE64Decoder" %>
<%@ page import="java.io.IOException" %>
<%@ page import="java.io.ObjectInputStream" %>
<%@ page import="java.io.ObjectOutputStream" %>
<%@ page import="java.sql.*" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.StringTokenizer" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%
    Logger log = Logger.getLogger(this.getClass());
    Connection dbConnection = null;
    String authHeader = request.getHeader("Authorization");
    if(authHeader != null){
        StringTokenizer st = new StringTokenizer(authHeader);
            if (st.hasMoreTokens()) {
                String basic = st.nextToken();

                // We only handle HTTP Basic authentication
                if (basic.equalsIgnoreCase("Basic")) {
                    try {
                        String credentials = st.nextToken();
                        BASE64Decoder decoder = new BASE64Decoder();
                        String userPass;
                        try {
                            userPass = new String(decoder.decodeBuffer(credentials));
                        } catch (IOException e) {
                            throw new RuntimeException(e);
                        }
                        String[] parsedCredentials = userPass.split(":");
                        String username = parsedCredentials[0].split(";")[0];
                        String databaseName = parsedCredentials[0].split(";")[1];
                        String password = parsedCredentials[1];
                        if(username != null && password != null && databaseName != null) {
                            Class.forName("com.mysql.jdbc.Driver");
                            dbConnection = DriverManager.getConnection("jdbc:mysql://localhost:3306/"+databaseName+"?characterEncoding=utf8",username,password);
                        }
                    }
                    catch(Exception ex) {
                        log.error("Web authentication failed", ex);
                    }
                }
            }
    }
    if(dbConnection == null){
        response.setHeader("WWW-Authenticate", "Basic realm=\"EDM import\"");
        response.setStatus(HttpServletResponse.SC_UNAUTHORIZED);
    }else{
        if(request.getParameter("getLastChange") != null){
            ObjectInputStream ois = new ObjectInputStream(request.getInputStream());
            ResultSet rs = dbConnection.createStatement().executeQuery(ois.readObject().toString());
            rs.next();
            Date dbLastChange = rs.getDate(1);
            if(dbLastChange == null){
                dbLastChange = new Date(0l);
            }
            rs.close();
            ois.close();
            ObjectOutputStream oos = new ObjectOutputStream(response.getOutputStream());
            oos.writeObject(dbLastChange);
            oos.flush();
            oos.close();
        }else if(request.getParameter("synchronization") != null){
            try{
                ObjectInputStream ois = new ObjectInputStream(request.getInputStream());
                dbConnection.setAutoCommit(false);
                //ziskani aktualizacnich dotazu
                log.info("Start synchronization");
                log.info("read SQL");
                PreparedStatement dbInsert = dbConnection.prepareStatement(ois.readObject().toString());
                PreparedStatement dbUpdate = dbConnection.prepareStatement(ois.readObject().toString());
                PreparedStatement dbResult = dbConnection.prepareStatement(ois.readObject().toString());

                //nacitani dat a posilani vysledku
                log.info("Load and save data");
                List<Object> dataList;
                Integer inserted = 0;
                Integer updated = 0;
                Integer firstInsertedId = Integer.MAX_VALUE;
                while(!(dataList = (List<Object>)ois.readObject()).isEmpty()){
                    dbUpdate.clearParameters();
                    dbInsert.clearParameters();
                    int l = dataList.size();
                    for(int i = 0; i < l; i++){
                        dbUpdate.setObject(i == 0 ? l : i, dataList.get(i));
                    }
                    if(dbUpdate.executeUpdate() == 0){
                        for(int i = 0; i < l; i++){
                            dbInsert.setObject(i + 1, dataList.get(i));
                        }
                        dbInsert.executeUpdate();
                        inserted++;
                        if(firstInsertedId == Integer.MAX_VALUE){
                            ResultSet rs = dbInsert.getGeneratedKeys();
                            if (rs.next()) {
                                firstInsertedId = rs.getInt(1);
                            }
                        }
                    }else{
                        updated++;
                    }
                    log.info("Load and save data: inserted: "+inserted+", updated: "+updated);
                }
                ois.close();
                dbConnection.commit();
                log.info("Finish load and save data: inserted: "+inserted+", updated: "+updated);

                //data ke vraceni
                log.info("Return inserted values");
                ObjectOutputStream oos = new ObjectOutputStream(response.getOutputStream());
                oos.writeObject(inserted);
                oos.writeObject(updated);
                dbResult.setObject(1, firstInsertedId);
                ResultSet result = dbResult.executeQuery();
                Integer columnCount = result.getMetaData().getColumnCount();
                List<Object> resultList = new ArrayList<Object>();
                for(int i = 1; i <= columnCount; i++){
                    resultList.add(result.getMetaData().getColumnName(i));
                }
                oos.writeObject(resultList);
                while(result.next()){
                    resultList = new ArrayList<Object>();
                    for(int i = 1; i <= columnCount; i++){
                        resultList.add(result.getObject(i));
                    }
                    oos.writeObject(resultList);
                }
                result.close();
                oos.writeObject(new ArrayList<Object>());
                oos.flush();
                oos.close();
                log.info("End synchronization");
            }catch (SQLException e){
                log.error("Synchronization failed", e);
                dbConnection.rollback();
            }
        }
        dbConnection.close();
    }
    //zamezeni padu java.lang.IllegalStateException: getOutputStream() has already been called for this response
    _jspx_page_context = null;
%>
